module OmniAuth
  module Strategies
    class InfinumId < OmniAuth::Strategies::OAuth2
      option :name, 'infinum_id'

      option :client_options, site: 'http://localhost:3000'

      uid do
        raw_info['uid']
      end

      info do
        {
          email: raw_info['email'],
          first_name: raw_info['first_name'],
          last_name: raw_info['last_name'],
          slack_username: raw_info['slack_username'],
          time_zone: raw_info['time_zone'],
          deactivated_at: raw_info['deactivated_at'],
          avatar_url: raw_info['avatar_url'],
          employee: raw_info['employee']
        }
      end

      def raw_info
        @raw_info ||= access_token.get('/oauth/me.json').parsed
      end
    end
  end
end
